package mains;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;
import java.util.LinkedList;
import java.util.List;

public class Excercise2_Consts {
	enum Scales{
		O1,
		OlogN,
		ONlogN,
		ON
	}
	
	public static void main(String[] args) throws IOException{
		String[] files = {
			"auswertungen_prioqueues/InitCmp",
			"auswertungen_prioqueues/InsertCmp",
			"auswertungen_prioqueues/GetMinCmp",
			"auswertungen_prioqueues/DelMinCmp",
			"auswertungen_prioqueues/DeleteCmp",
			"auswertungen_prioqueues/DecreasePrioCmp",
		};
		Scales[][] scales = {
			{Scales.ONlogN,Scales.ONlogN},
			{Scales.OlogN,Scales.OlogN},
			{Scales.O1,Scales.OlogN},
			{Scales.OlogN,Scales.OlogN},
			{Scales.ON,Scales.OlogN},
			{Scales.ON,Scales.OlogN}
		};
		
		for(int c=0; c<files.length; c++){
			Reader reader = new FileReader(files[c] + ".txt");
			BufferedReader r = new BufferedReader(reader);
			List<Integer> lelems = new LinkedList<Integer>();
			List<Double> lvalues = new LinkedList<Double>();
			
			String row = "";
			while((row = r.readLine()) != null){
				row = row.trim();
				if(!row.isEmpty() && Character.isDigit(row.charAt(0))){
					String[] s = row.split(" ");
					lelems.add(Integer.parseInt(s[0].trim()));
					lvalues.add(Double.parseDouble(s[1].trim()));
				}
			}
			int[] elems = new int[lelems.size()];
			double[] values = new double[lvalues.size()];
			int i = 0;
			for(int n : lelems)
				elems[i++] = n;
			int j = 0;
			for(double n : lvalues)
				values[j++] = n;
			
			r.close();
			reader.close();
			
			
			Writer writer = new FileWriter(files[c] + "_Consts.txt");
			BufferedWriter w = new BufferedWriter(writer);
			
			w.write("# Leftist Tree\n");
			for(int k=0; k<elems.length; k++){
				if(k == elems.length/2){
					w.write("\n\n# Binomial Heap\n");
				}
				String line;
				if(k < elems.length/2)
					line = elems[k] + " " + (values[k]/getScaleValue(scales[c][0], elems[k])) + "\n";
				else
					line = elems[k] + " " + (values[k]/getScaleValue(scales[c][1], elems[k])) + "\n";
				w.write(line);
			}
			
			w.close();
			writer.close();
		}
	}
	
	private static double getScaleValue(Scales scale, int elems){
		switch(scale){
		case O1:
			return 1.0;
		case OlogN:
			return Math.pow(Math.log(elems), 1/10.0);
		case ONlogN:
			return elems*Math.log(elems);
		case ON:
			return Math.pow(elems, 1/20.0);
		}
		return 0.0;
	}
}
